//+------------------------------------------------------------------+
//|                                                      IKH Pro.mq4 |
//|                                                    Howard Joseph |
//|                                          howard.joseph@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Howard Joseph"
#property link      "howard.joseph@gmail.com"

//---- input parameters
extern double    Lots=0.1;
extern int       IKH_Tenkan=9;
extern int       IKH_Kijun=26;
extern int       IKH_Senkou=52;
extern int       IKH_Shift=0;
extern int       Max_Slippage=5;
extern int       Max_Stop=500;
extern bool      Start_Now=false;
int Ticket,Trade_Direction,Trade_Level,Market_Direction,Last_Direction,Kijun_Stop;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   //----
   if(Start_Now == true) Market_Direction = 0;
   if(Start_Now == false)
     {
      if(iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_TENKANSEN,IKH_Shift) > iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_KIJUNSEN,IKH_Shift)) Market_Direction = 1;
      if(iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_TENKANSEN,IKH_Shift) < iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_KIJUNSEN,IKH_Shift)) Market_Direction = -1;
     }
   //----
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   //----
   
   //----
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   Last_Direction = Market_Direction;
   Kijun_Stop = iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_KIJUNSEN,IKH_Shift);
   if(iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_TENKANSEN,IKH_Shift) > iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_KIJUNSEN,IKH_Shift)) Market_Direction = 1;
   if(iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_TENKANSEN,IKH_Shift) < iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_KIJUNSEN,IKH_Shift)) Market_Direction = -1;
   if(Last_Direction != Market_Direction) Trade_Level = 0;
   if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES))
     {
      if(OrderType() == OP_BUY) Trade_Direction = 1;
      if(OrderType() == OP_SELL) Trade_Direction = -1;
     }
   
   
   //Buy Level 1 Open
   if(Market_Direction == 1 && (Bid > iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_KIJUNSEN,IKH_Shift)) && OrdersTotal() < 1 && Trade_Level < 1)
     {
      Ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,Max_Slippage,Max_Stop*Point,99999*Point,"IKH Pro BUY Level 1",1234,0,Green);
      Trade_Level ++;
     }
   //Sell Level 1 Open
   if(Market_Direction == -1 && (Bid < iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_KIJUNSEN,IKH_Shift)) && OrdersTotal() < 1 && Trade_Level > -1)
     {
      Ticket = OrderSend(Symbol(),OP_BUY,Lots,Bid,Max_Slippage,Max_Stop*Point,99999*Point,"IKH Pro SELL Level 1",4321,0,Red);
      Trade_Level --;
     }
   
   
   //Buy Level 2 Open
   if(Market_Direction == 1 && (Bid > iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_TENKANSEN,IKH_Shift)) && OrdersTotal() < 1 && Trade_Level > 0)
     {
      Ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,Max_Slippage,Max_Stop*Point,99999*Point,"IKH Pro BUY Level 1",1234,0,Green);
      Trade_Level ++;
     }
   //Sell Level 2 Open
   if(Market_Direction == -1 && (Bid < iIchimoku(NULL,0,IKH_Tenkan,IKH_Kijun,IKH_Senkou,MODE_TENKANSEN,IKH_Shift)) && OrdersTotal() < 1 && Trade_Level < 0)
     {
      Ticket = OrderSend(Symbol(),OP_BUY,Lots,Bid,Max_Slippage,Max_Stop*Point,99999*Point,"IKH Pro SELL Level ",4321,0,Red);
      Trade_Level --;
     }
   
   
   //Buy Stop
   if(Bid < Kijun_Stop-MarketInfo(NULL,MODE_SPREAD) && Trade_Direction > 0)
     {
      OrderClose(Ticket,Lots,Bid,5,CLR_NONE);
      Trade_Level ++;
     }
   //Sell Stop
   if(Bid > Kijun_Stop+MarketInfo(NULL,MODE_SPREAD) && Trade_Direction < 0)
     {
      OrderClose(Ticket,Lots,Ask,5,CLR_NONE);
      Trade_Level --;
     }
   
   
   return(0);
  }
//+------------------------------------------------------------------+